PlayerAgentManagement/UI-MVC/Models/Dto/AgentDto.cs
namespace PlayerAgentManagement.UI.Web.MVC.Models.Dto;

public class AgentDto
{
    
}

PlayerAgentManagement/UI-MVC/Models/Dto/ContractDto.cs
namespace PlayerAgentManagement.UI.Web.MVC.Models.Dto;

public class ContractDto
{
    
}

PlayerAgentManagement/UI-MVC/Models/Dto/NewAgentDto.cs
namespace PlayerAgentManagement.UI.Web.MVC.Models.Dto;

public class NewAgentDto
{
    
}

PlayerAgentManagement/UI-MVC/Models/Dto/NewContractDto.cs
namespace PlayerAgentManagement.UI.Web.MVC.Models.Dto;

public class NewContractDto
{
    
}

PlayerAgentManagement/UI-MVC/Models/Dto/NewPlayerDto.cs
namespace PlayerAgentManagement.UI.Web.MVC.Models.Dto;

public class NewPlayerDto
{
    
}

PlayerAgentManagement/UI-MVC/Models/Dto/NewTeamDto.cs
namespace PlayerAgentManagement.UI.Web.MVC.Models.Dto;

public class NewTeamDto
{
    
}

PlayerAgentManagement/UI-MVC/Models/Dto/PlayerDto.cs
namespace PlayerAgentManagement.UI.Web.MVC.Models.Dto;

public class PlayerDto
{
    
}

PlayerAgentManagement/UI-MVC/Models/Dto/TeamDto.cs
namespace PlayerAgentManagement.UI.Web.MVC.Models.Dto;

public class TeamDto
{
    
}

PlayerAgentManagement/UI-MVC/Models/ErrorViewModel.cs
namespace PlayerAgentManagement.UI.Web.MVC.Models;

public class ErrorViewModel
{
    public string? RequestId { get; set; }

    public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
}

PlayerAgentManagement/UI-MVC/Models/NewAgentViewModel.cs
using System.ComponentModel.DataAnnotations;

namespace PlayerAgentManagement.UI.Web.MVC.Models;

public class NewAgentViewModel
{
    [Required]
    [MaxLength(50)]
    public string Name { get; set; }
    [Required]
    [DataType(DataType.Date)]
    public DateTime BirthDate { get; set; }
    [MaxLength(20)] 
#nullable enable
    public string? PhoneNumber { get; set; }
    public int Id { get; set; }
}

PlayerAgentManagement/UI-MVC/Models/NewPlayerViewModel.cs
using System.ComponentModel.DataAnnotations;
using PlayerAgentManagement.BL.Domain;

namespace PlayerAgentManagement.UI.Web.MVC.Models;

public class NewPlayerViewModel
{
    [MinLength(2)]
    public string Name { get; set; }
    [DataType(DataType.Date)]
    public DateTime BirthDate { get; set; }
    [EnumDataType(typeof(Position))]
    public Position Position { get; set; }
    
    [Range(0, double.MaxValue)]
    public double Salary { get; set; }
    public int Id { get; set; }
}

PlayerAgentManagement/UI-MVC/Models/NewTeamViewModel.cs
using System.ComponentModel.DataAnnotations;
using PlayerAgentManagement.BL.Domain;

namespace PlayerAgentManagement.UI.Web.MVC.Models;

public class NewTeamViewModel
{
    [MinLength(2)]
    public string Name { get; set; }
    [DataType(DataType.Date)]
    public DateTime Founded { get; set; }
    [EnumDataType(typeof(Position))]
    public Position Position { get; set; }
    [StringLength(30, MinimumLength = 3)]
    public string Country { get; set; }
    public int Id { get; set; }
    
    
}

PlayerAgentManagement/UI-MVC/Controllers/AgentController.cs
using Microsoft.AspNetCore.Mvc;
using PlayerAgentManagement.BL;



namespace PlayerAgentManagement.UI.Web.MVC.Controllers;

public class AgentController : Controller
{
    private readonly IManager _manager;
    
    public AgentController(IManager manager)
    {
        _manager = manager;
    }
    
    [HttpGet]
    public IActionResult Index()
    {
        var agents = _manager.GetAllAgentsWithPlayers();
        return View(agents);
    }
    
    [HttpGet]
    public IActionResult Details(int id)
    {
        var agent = _manager.GetAgentWithPlayers(id);
        return View(agent);
    }
}

PlayerAgentManagement/UI-MVC/Controllers/Api/AgentsController.cs
namespace PlayerAgentManagement.UI.Web.MVC.Controllers.Api;

public class AgentsController
{
    
}

PlayerAgentManagement/UI-MVC/Controllers/Api/PlayersController.cs
namespace PlayerAgentManagement.UI.Web.MVC.Controllers.Api;

public class PlayersController
{
    
}

PlayerAgentManagement/UI-MVC/Controllers/Api/TeamsController.cs
namespace PlayerAgentManagement.UI.Web.MVC.Controllers.Api;

public class TeamsController
{
    
}

PlayerAgentManagement/UI-MVC/Controllers/HomeController.cs
using System.Diagnostics;
using Microsoft.AspNetCore.Mvc;
using PlayerAgentManagement.BL;
using PlayerAgentManagement.UI.Web.MVC.Models;

namespace PlayerAgentManagement.UI.Web.MVC.Controllers;

public class HomeController : Controller
{
    private readonly ILogger<HomeController> _logger;

    public HomeController(ILogger<HomeController> logger)
    {
        _logger = logger;
    }

    public IActionResult Index()
    {
        return View();
    }

    public IActionResult Privacy()
    {
        return View();
    }

    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    public IActionResult Error()
    {
        return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
    }
}

PlayerAgentManagement/UI-MVC/Controllers/PlayerController.cs
using PlayerAgentManagement.BL.Domain;
using PlayerAgentManagement.UI.Web.MVC.Models;

namespace PlayerAgentManagement.UI.Web.MVC.Controllers;
using Microsoft.AspNetCore.Mvc;
using BL;

public class PlayerController : Controller
{
    private readonly IManager _manager;
    private readonly ILogger<PlayerController> _logger;


    public PlayerController(IManager manager, ILogger<PlayerController> logger)
    {
        _manager = manager;
        _logger = logger;

    }
    [HttpGet]
    public IActionResult Index()
    {
        var players = _manager.GetAllPlayers();
        return View(players);
    }
    [HttpGet]
    public IActionResult Add()
    {
        return View();
    }
    [HttpPost]
    public IActionResult Add(NewPlayerViewModel player)
    {
        _logger.LogInformation("Add action called with player: {Player}", player);

        if (!ModelState.IsValid)
        {
            foreach (var modelState in ModelState)
            {
                foreach (var error in modelState.Value.Errors)
                {
                    _logger.LogWarning("Validation error on {Field}: {ErrorMessage}", modelState.Key, error.ErrorMessage);
                }
            }
            return View(player);
        }

        _manager.AddPlayer(player.Name, player.BirthDate, player.Position, player.Salary);
        ModelState.Clear();

        _logger.LogInformation("Player added successfully, redirecting to Index action");

        return RedirectToAction("Index", "Player");
    }
    [HttpGet]
    public IActionResult Details(int id)
    {
        var player = _manager.GetPlayerWithContracts(id);
        if (player == null)
        {
            return NotFound();
        }
        return View(player);
    }
    
}

PlayerAgentManagement/UI-MVC/Controllers/TeamController.cs
using Microsoft.AspNetCore.Mvc;
using PlayerAgentManagement.BL;

namespace PlayerAgentManagement.UI.Web.MVC.Controllers;

public class TeamController : Controller
{
    private readonly IManager _manager;
    
    public TeamController(IManager manager)
    {
        _manager = manager;
    }
    
    [HttpGet]
    public IActionResult Index()
    {
        var teams = _manager.GetAllTeamsWithContracts();
        return View(teams);
    }
    
    [HttpGet]
    public IActionResult Details(int id)
    {
        var team = _manager.GetTeamWithContracts(id);
        return View(team);
    }
    
}

PlayerAgentManagement/UI-MVC/Views/Agent/Details.cshtml
@model PlayerAgentManagement.BL.Domain.Agent

@{
    ViewBag.Title = "Agent details";
    Layout = "_Layout";
}

<h2>Agent details</h2>

<section class="my-3">
    <div class="mb-3 row">
        <label for="name-label" class="col-sm-2 fw-bold">Name</label>
        <span id="name-label" class="col-sm-10">@Model.Name</span>
    </div>
    <div class="mb-3 row">
        <label for="birthdate-label" class="col-sm-2 fw-bold">BirthDate</label>
        <span id="birthdate-label" class="col-sm-10">@Model.BirthDate</span>
    </div>
    <div class="mb-3 row">
        <label for="position-label" class="col-sm-2 fw-bold">Phone Number</label>
        <span id="position-label" class="col-sm-10">@Model.PhoneNumber</span>
    </div>
</section>


<partial name="_PlayerOverview" model="Model.Players" />

PlayerAgentManagement/UI-MVC/Views/Agent/Index.cshtml
@using PlayerAgentManagement.BL.Domain
@model IEnumerable<PlayerAgentManagement.BL.Domain.Agent>

@{
    ViewBag.Title = "All Agents";
    Layout = "_Layout";
}

<h2>All Agents</h2>

<table class="table">
    <thead>
    <tr>
        <th>Name</th>
        <th>BirthDate</th>
        <th>PhoneNumber</th>
        <th>Details</th>
    </tr>
    </thead>
    <tbody>
    @foreach (Agent agent in Model)
    {
        <tr>
            <td>@agent.Name</td>
            <td>@agent.BirthDate</td>
            <td>@agent.PhoneNumber</td>
            <td><a asp-controller="Agent" asp-action="Details" asp-route-id="@agent.Id">Details</a></td>
        </tr>
    }
</table>

PlayerAgentManagement/UI-MVC/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

PlayerAgentManagement/UI-MVC/Views/Player/Add.cshtml
@using PlayerAgentManagement.BL.Domain
@model NewPlayerViewModel

@{
    ViewBag.Title = "Add Player";
    Layout = "_Layout";
}

<h2>Add Player</h2>

<form asp-controller="Player" asp-action="Add" method="post">
    <div class="mb-3 row">
        <label class="col-sm-2 form-label" asp-for="Name"></label>
        <div class="col-sm-10">
            <input class="form-control" asp-for="Name">
                    <span asp-validation-for="Name" class="text-danger"></span>
        </div>
    </div>
    <div class="mb-3 row">
        <label class="col-sm-2 form-label" asp-for="BirthDate"></label>
        <div class="col-sm-10">
            <input class="form-control" asp-for="BirthDate">
                    <span asp-validation-for="BirthDate" class="text-danger"></span>
        </div>
    </div>
    <div class="mb-3 row">
        <label class="col-sm-2 form-label" asp-for="Position"></label>
        <div class="col-sm-10">
        <select class="form-control" asp-for="Position" asp-items="Html.GetEnumSelectList<Position>()" name="Position"></select>
        </div>
    </div>
    <div class="mb-3 row">
        <label class="col-sm-2 form-label" asp-for="Salary"></label>
        <div class="col-sm-10">
            <input class="form-control" asp-for="Salary">
                    <span asp-validation-for="Salary" class="text-danger"></span>
        </div>
    </div>
    <button type="submit" class="btn btn-primary">Add</button>
</form>

@section Scripts
{
    <partial name="_ValidationScriptsPartial"/>
}

PlayerAgentManagement/UI-MVC/Views/Player/Details.cshtml
@model PlayerAgentManagement.BL.Domain.Player

@{
    ViewBag.Title = "Player details";
    Layout = "_Layout";
}

<h2>Player details</h2>

<section class="my-3">
    <div class="mb-3 row">
        <label for="name-label" class="col-sm-2 fw-bold">Name</label>
        <span id="name-label" class="col-sm-10">@Model.Name</span>
    </div>
    <div class="mb-3 row">
        <label for="birthdate-label" class="col-sm-2 fw-bold">BirthDate</label>
        <span id="birthdate-label" class="col-sm-10">@Model.BirthDate</span>
    </div>
    <div class="mb-3 row">
        <label for="position-label" class="col-sm-2 fw-bold">Position</label>
        <span id="position-label" class="col-sm-10">@Model.Position</span>
    </div>
    <div class="mb-3 row">
        <label for="salary-label" class="col-sm-2 fw-bold">Salary</label>
        <span id="salary-label" class="col-sm-10">@Model.Salary</span>
    </div>
</section>

<partial name="_TeamOverview" model="Model.Contracts" />

PlayerAgentManagement/UI-MVC/Views/Player/Index.cshtml
@using PlayerAgentManagement.BL.Domain
@model IEnumerable<PlayerAgentManagement.BL.Domain.Player>

@{
    ViewBag.Title = "All Players";
    Layout = "_Layout";
}

<h2>All Players</h2>

<table class="table">
    <thead>
    <tr>
        <th>Name</th>
        <th>Birth date</th>
        <th>Position</th>
        <th>Salary</th>
        <th></th>
    </tr>
    </thead>
    <tbody>
    @foreach (Player player in Model)
    {
        <tr>
            <td>@player.Name</td>
            <td>@player.BirthDate</td>
            <td>@player.Position</td>
            <td>@player.Salary</td>
            <td><a asp-controller="Player" asp-action="Details" asp-route-id="@player.Id">Details</a></td>
        </tr>
    }
</table>

PlayerAgentManagement/UI-MVC/Views/Shared/_AgentOverview.cshtml
@using PlayerAgentManagement.BL.Domain
@model PlayerAgentManagement.BL.Domain.Agent

<table class="table">
    <thead>
    <tr>
        <th>Name</th>
        <th>BirthDate</th>
        <th>PhoneNumber</th>
        <th>Details</th>
    </tr>
    </thead>
    <tbody>
    <tr>
        <td>@Model.Name</td>
        <td>@Model.BirthDate</td>
        <td>@Model.PhoneNumber</td>
            <td><a asp-controller="Agent" asp-action="Details" asp-route-id="@Model.Id">Details</a></td>
    </tr>
    </tbody>
</table>

PlayerAgentManagement/UI-MVC/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>@ViewData["Title"] - Player Management</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css"/>
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true"/>
</head>
<body>
<header>
    <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
        <div class="container-fluid">
            <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">UI_MVC</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                    aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                <ul class="navbar-nav flex-grow-1">
                    <li class="nav-item">
                        <a class="nav-link text-dark" asp-area="" asp-controller="Player" asp-action="Index">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link text-dark" asp-area="" asp-controller="Player" asp-action="Add">Add Player</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                    </li>
                </ul>
            </div>
        </div>
    </nav>
</header>
<div class="container">
    <main role="main" class="pb-3">
        @RenderBody()
    </main>
</div>

<footer class="border-top footer text-muted">
    <div class="container">
        &copy; @DateTime.Now.Year - Sami Filjak - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
    </div>
</footer>
<script src="~/lib/jquery/dist/jquery.min.js"></script>
<script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
<script src="~/js/site.js" asp-append-version="true"></script>
@await RenderSectionAsync("Scripts", required: false)
</body>
</html>

PlayerAgentManagement/UI-MVC/Views/Shared/_PlayerOverview.cshtml
@model IEnumerable<PlayerAgentManagement.BL.Domain.Contract>

<table class="table">
    <thead>
    <tr>
        <th>Name</th>
        <th>Birth date</th>
        <th>Position</th>
        <th>Salary</th>
        <th>Details</th>
    </tr>
    </thead>
    <tbody>
    @foreach (var contract in Model)
    {
        <tr>
            <td>@contract.Player.Name</td>
            <td>@contract.Player.BirthDate</td>
            <td>@contract.Player.Position</td>
            <td>@contract.Player.Salary</td>
            <td><a asp-controller="Player" asp-action="Details" asp-route-id="@contract.Player.Id">Details</a></td>
        </tr>
    }
    </tbody>
</table>

PlayerAgentManagement/UI-MVC/Views/Shared/_TeamOverview.cshtml
@using Microsoft.EntityFrameworkCore.Infrastructure
@model IEnumerable<PlayerAgentManagement.BL.Domain.Contract>

<table class="table">
    
    <thead>
    <tr>
        <th>Name</th>
        <th>Founded</th>
        <th>Country</th>
        <th>Details</th>
    </tr>
    </thead>
    <tbody>
        @foreach (var contract in Model)
        {
            <tr>
                <td>@contract.Team.Name</td>
                <td>@contract.Team.Founded</td>
                <td>@contract.Team.Country</td>
                <td><a asp-controller="Team" asp-action="Details" asp-route-id="@contract.Team.Id">Details</a></td>
            </tr>
        }
</table>

PlayerAgentManagement/UI-MVC/Views/Team/Details.cshtml
@model PlayerAgentManagement.BL.Domain.Team

@{
    ViewBag.Title = "Team details";
    Layout = "_Layout";
}

<h2>Team details</h2>

<section class="my-3">
    <div class="mb-3 row">
        <label for="name-label" class="col-sm-2 fw-bold">Name</label>
        <span id="name-label" class="col-sm-10">@Model.Name</span>
    </div>
    <div class="mb-3 row">
        <label for="founded-label" class="col-sm-2 fw-bold">Founded</label>
        <span id="founded-label" class="col-sm-10">@Model.Founded</span>
    </div>
    <div class="mb-3 row">
        <label for="country-label" class="col-sm-2 fw-bold">Country</label>
        <span id="country-label" class="col-sm-10">@Model.Country</span>
    </div>
</section>

<partial name="_PlayerOverview" model="Model.Contracts" />

PlayerAgentManagement/UI-MVC/Views/Team/Index.cshtml
@using PlayerAgentManagement.BL.Domain
@model IEnumerable<PlayerAgentManagement.BL.Domain.Team>

@{
    ViewBag.Title = "All Teams";
    Layout = "_Layout";
}

<h2>All Teams</h2>

<table class="table">
    <thead>
    <tr>
        <th>Name</th>
        <th>Founded</th>
        <th>Country</th>
        <th>Details</th>
    </tr>
    </thead>
    <tbody>
    @foreach (Team team in Model)
    {
        <tr>
            <td>@team.Name</td>
            <td>@team.Founded</td>
            <td>@team.Country</td>
            <td><a asp-controller="Team" asp-action="Details" asp-route-id="@team.Id">Details</a></td>
        </tr>
    }
</table>